# -*- coding: utf-8 -*-
#HW3.3 检查HTML文档标记是否匹配
from pythonds.basic.stack import Stack

def parChecker(symbloString):
    s=Stack()
    balanced=True
    index=0
    cache=""
    while index<len(symbloString) and balanced:
        symbol=symbloString[index]
        if symbol == "<":
            if cache:
                return False
            cache+=symbol
        elif symbol == ">":
            if not cache:
                return False
            cache+=symbol
            if isclose(cache):
                if not matches(s.pop(), cache):
                    return False
            else:
                s.push(cache)
            cache=""
        else:
            if cache:
                cache+=symbol
        index=index+1
    if balanced and s.isEmpty():
        return True
    else:
        return False

def isclose(item):
    return item[1]=="/"

def matches(open,close):
    if close[1]!="/":
        return False
    open=open[1:-1];
    close=close[2:-1];
    return open==close

def checkFile(filename):
    f=open(filename)
    try:
        raw=f.read()
        if parChecker(raw):
            print("Tags in file "+filename+" is matched")
        else:
            print("Tags in file "+filename+" is NOT matched")
    except:
        print("Error when read file")
    finally:
        f.close()

print(parChecker('<div>asdfa</div>'))
print(parChecker('<div>asdf</p>'))
checkFile("test_matched.html")
checkFile("test_not_matched.html")