# -*- coding: utf-8 -*-
from pythonds.basic.stack import Stack
def domath(op,num1,num2):
    if op=="+":
        return num1+num2
    elif op=="-":
        return num1-num2
    elif op=="*":
        return num1*num2
    else:
        return num1/num2
def postfixEval(postfixexpr):
    prec={}
    prec["*"]=3
    prec["/"]=3
    prec["+"]=2
    prec["-"]=2
    prec["("]=1
    opstack=Stack()                                      #操作符
    operandstack=Stack()                                 #操作数
    tokenlist=postfixexpr.split( )
    for token in tokenlist:
        if token in "0123456789":
            operandstack.push(int(token))                #将操作数转换为整数型并放入操作数的栈中
        elif token=='(':
            opstack.push(token)
        elif token==')':
            toptoken=opstack.pop()
            while toptoken!='(':
                num2=operandstack.pop()              #进行数据运算
                num1=operandstack.pop()
                result=domath(toptoken,num1,num2)
                operandstack.push(result)            #将运行结果放入操作数的栈中
                toptoken=opstack.pop()
        else:
            while (not opstack.isEmpty())and(prec[opstack.peek()]>=prec[token]):
                num2 = operandstack.pop()                       #进行数据运算
                num1 = operandstack.pop()
                result = domath(opstack.pop(), num1, num2)      #将运行结果放入操作数的栈中
                operandstack.push(result)
            opstack.push(token)
    while not opstack.isEmpty():
        num2 = operandstack.pop()                                #进行数据运算
        num1 = operandstack.pop()
        result = domath(opstack.pop(), num1, num2)               #将运行结果放入操作数的栈中
        operandstack.push(result)
    return operandstack.pop()