# -*- coding: utf-8 -*-
#HW3.1 中缀转后缀并对后缀求值
from pythonds.basic.stack import Stack
def infixToPostfixAndEval(infixexpr):
    prec={}
    prec["*"]=3
    prec["/"]=3
    prec["+"]=2
    prec["-"]=2
    prec["("]=1
    prec["$"]=0
    opStack=Stack()
    operandStack=Stack()
    cache=""
    tokenList=infixexpr+"$"

    for token in tokenList:
        if token in "0123456789":
            cache += token;
        elif token=='(':
            if cache:
                operandStack.push(int(cache))
                cache=""
            opStack.push(token)
        elif token==')':
            if cache:
                operandStack.push(int(cache))
                cache=""
            topToken=opStack.pop()
            while topToken !='(':
                operand2=operandStack.pop()
                operand1=operandStack.pop()
                result=doMath(topToken,operand1,operand2)
                operandStack.push(result)
                topToken=opStack.pop()
        else:
            if cache:
                operandStack.push(int(cache))
                cache=""
            while(not opStack.isEmpty()) and (prec[opStack.peek()]>=prec[token]):
                operand2=operandStack.pop()
                operand1=operandStack.pop()
                topToken=opStack.pop()
                result=doMath(topToken,operand1,operand2)
                operandStack.push(result)
            opStack.push(token)
    return operandStack.pop()

def doMath(op,op1,op2):
    if op=="*":
        return op1*op2
    elif op=="/":
        return op1/op2
    elif op=="+":
        return op1+op2
    else:
        return op1-op2

print(infixToPostfixAndEval('123+(456*2)/3'))
