#检查HTML标记是否匹配
from pythonds.basic.stack import Stack
import re

def check(string):	#主要函数
	s = Stack()
	balanced = True
	All = get(string)
	try:
		for token in All:
			if not '</' in token:
				s.push(token)
			else:
				if s.isEmpty():
					balanced = False
				else:
					top = s.pop()
					if not matches(top, token):
						balanced = False
		if balanced and s.isEmpty():
			return True
		else:
			return False
	except:		#对于会让matches出错的‘<>’或者其它情况返回False
		return	False

def matches(left, right):	#检查一对标记是否匹配
	l = re.match(r'(<)(.+?)(>)', left).group(2)
	r = re.match(r'(</)(.+?)(>)', right).group(2)
	if l == r:
		return True
		
def get(string):	#将传入的字符串中所有<...>形式的字符串切片并放入数组
	return re.findall(r'(<.+?>)', string)