from pythonds.basic.stack import Stack
def op(string,x,y):  #将'+-*/^'转化为运算
    if string=='+':
        return y+x
    if string=='-':
        return y-x
    if string=='*':
        return y*x
    if string=='/':
        return y/x
    if string=='^':
        return y**x
def postfix_calculator(standard_string): #定义运算函数,参数为一个标准运算字符串（操作符与操作数之间用空格隔开）
    prec={}
    prec['^']=4
    prec['*']=3
    prec['/']=3
    prec['+']=2
    prec['-']=2
    prec['(']=1
    l=standard_string.split(sep=' ')
    m=Stack()  #栈m用来存放运算符和'('
    n=Stack()   #栈n用来存放运算数
    for i in l:
        if i in '+-*/^':
            while (not m.isEmpty()) and (prec[i]<=prec[m.peek()]):  #如果前一个运算符优先级不比现在的低，进行运算
                n.push(op(m.pop(),n.pop(),n.pop()))
            m.push(i)
        elif i=='(':
            m.push(i)
        elif i == ')': #遇到')'一直运算到遇到'('为止
            while m.peek()!='(':
                n.push(op(m.pop(),n.pop(),n.pop()))
            m.pop()
        else:
            n.push(int(i))
    while not m.isEmpty(): #循环完之后如果栈不空继续运算
        n.push(op(m.pop(),n.pop(),n.pop()))
    return n.pop()  #最后栈n中的数就是计算结果
            
